3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
49 if test "$1" = "#unmatched"
56 # Print a submodule configuration setting
62 # Checks in the usual git-config places first (for overrides),
63 # otherwise it falls back on .gitmodules. This allows you to
64 # distribute project-wide defaults in .gitmodules, while still
65 # customizing individual repositories if necessary. If the option is
66 # not in .gitmodules either, print a default value.
68 get_submodule_config () {
72 value=$(git config submodule."$name"."$option")
75 value=$(git config -f .gitmodules submodule."$name"."$option")
77 printf '%s' "${value:-$default}"
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85 # Sanitize the local git environment for use within a submodule. We
86 # can't simply use clear_local_git_env since we want to preserve some
87 # of the settings from GIT_CONFIG_PARAMETERS.
88 sanitize_submodule_env()
90 save_config=$GIT_CONFIG_PARAMETERS
92 GIT_CONFIG_PARAMETERS=$save_config
93 export GIT_CONFIG_PARAMETERS
97 # Add a new submodule to the working tree, .gitmodules and the index
101 # optional branch is stored in global branch variable
105 # parse $args after "submodule ... add".
111 case "$2" in '') usage ;; esac
122 case "$2" in '') usage ;; esac
127 reference_path="${1#--reference=}"
130 case "$2" in '') usage ;; esac
135 case "$2" in '') usage ;; esac
156 if test -n "$reference_path"
158 is_absolute_path "$reference_path" ||
159 reference_path="$wt_prefix$reference_path"
161 reference="--reference=$reference_path"
167 if test -z "$sm_path"; then
168 sm_path=$(printf '%s\n' "$repo" |
169 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
172 if test -z "$repo" || test -z "$sm_path"; then
176 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
178 # assure repo is absolute or relative to parent
181 test -z "$wt_prefix" ||
182 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
184 # dereference source url relative to parent's url
185 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
192 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
197 # multiple //; leading ./; /./; /../; trailing /
198 sm_path=$(printf '%s/\n' "$sm_path" |
210 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index")"
213 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
214 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
217 if test -z "$force" &&
218 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
220 eval_gettextln "The following path is ignored by one of your .gitignore files:
222 Use -f if you really want to add it." >&2
226 if test -n "$custom_name"
228 sm_name="$custom_name"
233 if ! git submodule--helper check-name "$sm_name"
235 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
238 # perhaps the path exists and is already a git repo, else clone it
239 if test -e "$sm_path"
241 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
243 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
245 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
249 if test -d ".git/modules/$sm_name"
253 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
254 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
255 die "$(eval_gettextln "\
256 If you want to reuse this local git directory instead of cloning again from
258 use the '--force' option. If the local git directory is not the correct repo
259 or you are unsure what this means choose another name with the '--name' option.")"
261 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
264 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
266 sanitize_submodule_env
268 # ash fails to wordsplit ${branch:+-b "$branch"...}
270 '') git checkout -f -q ;;
271 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
273 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
275 git config submodule."$sm_name".url "$realrepo"
277 git add --no-warn-embedded-repo $force "$sm_path" ||
278 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
280 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
281 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
284 git config -f .gitmodules submodule."$sm_name".branch "$branch"
286 git add --force .gitmodules ||
287 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
289 # NEEDSWORK: In a multi-working-tree world, this needs to be
290 # set in the per-worktree config.
291 if git config --get submodule.active >/dev/null
293 # If the submodule being adding isn't already covered by the
294 # current configured pathspec, set the submodule's active flag
295 if ! git submodule--helper is-active "$sm_path"
297 git config submodule."$sm_name".active "true"
300 git config submodule."$sm_name".active "true"
305 # Execute an arbitrary command sequence in each checked out
308 # $@ = command to execute
312 # parse $args after "submodule ... foreach".
334 # dup stdin so that it can be restored when running the external
335 # command in the subshell (and a recursive call to this function)
339 git submodule--helper list --prefix "$wt_prefix" ||
342 while read -r mode sha1 stage sm_path
344 die_if_unmatched "$mode" "$sha1"
345 if test -e "$sm_path"/.git
347 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
348 say "$(eval_gettext "Entering '\$displaypath'")"
349 name=$(git submodule--helper name "$sm_path")
351 prefix="$prefix$sm_path/"
352 sanitize_submodule_env
354 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
355 # we make $path available to scripts ...
363 if test -n "$recursive"
365 cmd_foreach "--recursive" "$@"
368 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
374 # Register submodules in .git/config
376 # $@ = requested paths (default to all)
380 # parse $args after "submodule ... init".
401 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
405 # Unregister submodules from .git/config and remove their work tree
409 # parse $args after "submodule ... deinit".
437 if test -n "$deinit_all" && test "$#" -ne 0
439 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
442 if test $# = 0 && test -z "$deinit_all"
444 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
448 git submodule--helper list --prefix "$wt_prefix" "$@" ||
451 while read -r mode sha1 stage sm_path
453 die_if_unmatched "$mode" "$sha1"
454 name=$(git submodule--helper name "$sm_path") || exit
456 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
458 # Remove the submodule work tree (unless the user already did it)
459 if test -d "$sm_path"
461 # Protect submodules containing a .git directory
462 if test -d "$sm_path/.git"
464 die "$(eval_gettext "\
465 Submodule work tree '\$displaypath' contains a .git directory
466 (use 'rm -rf' if you really want to remove it including all of its history)")"
471 git rm -qn "$sm_path" ||
472 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
475 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
476 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
479 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
481 # Remove the .git/config entries (unless the user already did it)
482 if test -n "$(git config --get-regexp submodule."$name\.")"
484 # Remove the whole section so we have a clean state when
485 # the user later decides to init this submodule again
486 url=$(git config submodule."$name".url)
487 git config --remove-section submodule."$name" 2>/dev/null &&
488 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
493 is_tip_reachable () (
494 sanitize_submodule_env &&
496 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
500 fetch_in_submodule () (
501 sanitize_submodule_env &&
508 git fetch $(get_default_remote) "$@" ;;
513 # Update each submodule path to correct revision, using clone and checkout as needed
515 # $@ = requested paths (default to all)
519 # parse $args after "submodule ... update".
527 progress="--progress"
549 case "$2" in '') usage ;; esac
550 reference="--reference=$2"
566 recommend_shallow="--recommend-shallow"
568 --no-recommend-shallow)
569 recommend_shallow="--no-recommend-shallow"
572 case "$2" in '') usage ;; esac
580 case "$2" in '') usage ;; esac
603 cmd_init "--" "$@" || return
607 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
608 ${progress:+"$progress"} \
609 ${wt_prefix:+--prefix "$wt_prefix"} \
610 ${prefix:+--recursive-prefix "$prefix"} \
611 ${update:+--update "$update"} \
612 ${reference:+"$reference"} \
613 ${depth:+--depth "$depth"} \
614 ${require_init:+--require-init} \
615 ${recommend_shallow:+"$recommend_shallow"} \
617 "$@" || echo "#unmatched" $?
620 while read -r mode sha1 stage just_cloned sm_path
622 die_if_unmatched "$mode" "$sha1"
624 name=$(git submodule--helper name "$sm_path") || exit
625 if ! test -z "$update"
627 update_module=$update
629 update_module=$(git config submodule."$name".update)
630 if test -z "$update_module"
632 update_module="checkout"
636 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
638 if test $just_cloned -eq 1
641 case "$update_module" in
642 merge | rebase | none)
643 update_module=checkout ;;
646 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
647 git rev-parse --verify HEAD) ||
648 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
653 branch=$(git submodule--helper remote-branch "$sm_path")
654 if test -z "$nofetch"
656 # Fetch remote before determining tracking $sha1
657 fetch_in_submodule "$sm_path" $depth ||
658 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
660 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
661 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
662 git rev-parse --verify "${remote_name}/${branch}") ||
663 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
666 if test "$subsha1" != "$sha1" || test -n "$force"
669 # If we don't already have a -f flag and the submodule has never been checked out
670 if test -z "$subsha1" && test -z "$force"
675 if test -z "$nofetch"
677 # Run fetch only if $sha1 isn't present or it
678 # is not reachable from a ref.
679 is_tip_reachable "$sm_path" "$sha1" ||
680 fetch_in_submodule "$sm_path" $depth ||
681 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
683 # Now we tried the usual fetch, but $sha1 may
684 # not be reachable from any of the refs
685 is_tip_reachable "$sm_path" "$sha1" ||
686 fetch_in_submodule "$sm_path" $depth "$sha1" ||
687 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
691 case "$update_module" in
693 command="git checkout $subforce -q"
694 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
695 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
699 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
700 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
701 must_die_on_failure=yes
705 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
706 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
707 must_die_on_failure=yes
710 command="${update_module#!}"
711 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
712 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
713 must_die_on_failure=yes
716 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
719 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
722 elif test -n "$must_die_on_failure"
724 die_with_status 2 "$die_msg"
726 err="${err};$die_msg"
731 if test -n "$recursive"
734 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
736 sanitize_submodule_env
743 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
746 err="${err};$die_msg"
749 die_with_status $res "$die_msg"
774 sanitize_submodule_env
776 git describe "$2" 2>/dev/null ||
777 git describe --tags "$2" 2>/dev/null ||
778 git describe --contains "$2" 2>/dev/null ||
779 git describe --all --always "$2"
782 test -z "$revname" || revname=" ($revname)"
785 # Show commit summary for submodules in index or working tree
787 # If '--cached' is given, show summary between index and given commit,
788 # or between working tree and given commit
790 # $@ = [commit (default 'HEAD'),] requested paths (default all)
797 # parse $args after "submodule ... summary".
812 isnumber "$summary_limit" || usage
816 summary_limit="${1#--summary-limit=}"
817 isnumber "$summary_limit" || usage
833 test $summary_limit = 0 && return
835 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
839 elif test -z "$1" || test "$1" = "HEAD"
841 # before the first commit: compare with an empty tree
842 head=$(git hash-object -w -t tree --stdin </dev/null)
843 test -z "$1" || shift
851 die "$(gettext "The --cached option cannot be used with the --files option")"
857 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
858 # Get modified modules cared by user
859 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
860 sane_egrep '^:([0-7]* )?160000' |
861 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
863 # Always show modules deleted or type-changed (blob<->module)
864 if test "$status" = D || test "$status" = T
866 printf '%s\n' "$sm_path"
869 # Respect the ignore setting for --for-status.
870 if test -n "$for_status"
872 name=$(git submodule--helper name "$sm_path")
873 ignore_config=$(get_submodule_config "$name" ignore none)
874 test $status != A && test $ignore_config = all && continue
876 # Also show added or modified modules which are checked out
877 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
878 printf '%s\n' "$sm_path"
882 test -z "$modules" && return
884 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
885 sane_egrep '^:([0-7]* )?160000' |
887 while read -r mod_src mod_dst sha1_src sha1_dst status name
889 if test -z "$cached" &&
890 test $sha1_dst = 0000000000000000000000000000000000000000
894 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
896 100644 | 100755 | 120000)
897 sha1_dst=$(git hash-object $name)
903 eval_gettextln "unexpected mode \$mod_dst" >&2
910 test $mod_src = 160000 &&
911 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
914 test $mod_dst = 160000 &&
915 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
918 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
921 case "$missing_src,$missing_dst" in
923 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
926 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
929 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
934 if test $mod_src = 160000 && test $mod_dst = 160000
936 range="$sha1_src...$sha1_dst"
937 elif test $mod_src = 160000
943 GIT_DIR="$name/.git" \
944 git rev-list --first-parent $range -- | wc -l
946 total_commits=" ($(($total_commits + 0)))"
950 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
951 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
954 blob="$(gettext "blob")"
955 submodule="$(gettext "submodule")"
956 if test $mod_dst = 160000
958 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
960 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
963 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
967 # Don't give error msg for modification whose dst is not submodule
968 # i.e. deleted or changed to blob
969 test $mod_dst = 160000 && echo "$errmsg"
971 if test $mod_src = 160000 && test $mod_dst = 160000
974 test $summary_limit -gt 0 && limit="-$summary_limit"
975 GIT_DIR="$name/.git" \
976 git log $limit --pretty='format: %m %s' \
977 --first-parent $sha1_src...$sha1_dst
978 elif test $mod_dst = 160000
980 GIT_DIR="$name/.git" \
981 git log --pretty='format: > %s' -1 $sha1_dst
983 GIT_DIR="$name/.git" \
984 git log --pretty='format: < %s' -1 $sha1_src
992 # List all submodules, prefixed with:
993 # - submodule not initialized
994 # + different revision checked out
996 # If --cached was specified the revision in the index will be printed
997 # instead of the currently checked out revision.
999 # $@ = requested paths (default to all)
1003 # parse $args after "submodule ... status".
1031 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1032 echo "#unmatched" $?
1034 while read -r mode sha1 stage sm_path
1036 die_if_unmatched "$mode" "$sha1"
1037 name=$(git submodule--helper name "$sm_path") || exit
1038 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1039 if test "$stage" = U
1041 say "U$sha1 $displaypath"
1044 if ! git submodule--helper is-active "$sm_path" ||
1046 ! test -d "$sm_path"/.git &&
1047 ! test -f "$sm_path"/.git
1050 say "-$sha1 $displaypath"
1053 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1055 set_name_rev "$sm_path" "$sha1"
1056 say " $sha1 $displaypath$revname"
1058 if test -z "$cached"
1060 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1062 set_name_rev "$sm_path" "$sha1"
1063 say "+$sha1 $displaypath$revname"
1066 if test -n "$recursive"
1069 prefix="$displaypath/"
1070 sanitize_submodule_env
1075 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1080 # Sync remote urls for submodules
1081 # This makes the value for remote.$remote.url match the value
1082 # specified in .gitmodules.
1111 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1112 echo "#unmatched" $?
1114 while read -r mode sha1 stage sm_path
1116 die_if_unmatched "$mode" "$sha1"
1118 # skip inactive submodules
1119 if ! git submodule--helper is-active "$sm_path"
1124 name=$(git submodule--helper name "$sm_path")
1125 url=$(git config -f .gitmodules --get submodule."$name".url)
1127 # Possibly a url relative to parent
1130 # rewrite foo/bar as ../.. to find path from
1131 # submodule work tree to superproject work tree
1132 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1133 # guarantee a trailing /
1134 up_path=${up_path%/}/ &&
1135 # path from submodule work tree to submodule origin repo
1136 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1137 # path from superproject work tree to submodule origin repo
1138 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1141 sub_origin_url="$url"
1142 super_config_url="$url"
1146 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1147 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1148 git config submodule."$name".url "$super_config_url"
1150 if test -e "$sm_path"/.git
1153 sanitize_submodule_env
1155 remote=$(get_default_remote)
1156 git config remote."$remote".url "$sub_origin_url"
1158 if test -n "$recursive"
1160 prefix="$prefix$sm_path/"
1170 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1173 # This loop parses the command line arguments to find the
1174 # subcommand name to dispatch. Parsing of the subcommand specific
1175 # options are primarily done by the subcommand implementations.
1176 # Subcommand specific options such as --branch and --cached are
1177 # parsed here as well, for backward compatibility.
1179 while test $# != 0 && test -z "$command"
1182 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1212 # No command word defaults to "status"
1213 if test -z "$command"
1223 # "-b branch" is accepted only by "add"
1224 if test -n "$branch" && test "$command" != add
1229 # "--cached" is accepted only by "status" and "summary"
1230 if test -n "$cached" && test "$command" != status && test "$command" != summary